#ifndef _LOOKUP_H_
#define _LOOKUP_H_

#include "kpatch-elf.h"
#define KSYM_NAME_LEN 128

struct lookup_table;

struct lookup_result {
	unsigned long value;
	unsigned long size;
	unsigned long pos;
};

struct sym_compare_type {
	char *name;
	int type;
};

struct lookup_refsym {
	char *name;
	unsigned long value;
};

struct lookup_table *lookup_open(char *symtab_path, char *symvers_path,
				 char *hint, struct sym_compare_type *locals,
				 char *kallsyms);
void lookup_close(struct lookup_table *table);
int lookup_local_symbol(struct lookup_table *table, char *name,
                        struct lookup_result *result);
int lookup_global_symbol(struct lookup_table *table, char *name,
                         struct lookup_result *result);
int lookup_is_exported_symbol(struct lookup_table *table, char *name);
char *lookup_exported_symbol_objname(struct lookup_table *table, char *name);
int lookup_is_duplicate_symbol(struct lookup_table *table, char *name,
		char *objname, unsigned long pos);
int lookup_ref_symbol_offset(struct lookup_table *table, char *name,
		struct lookup_refsym *refsym, char *objname,
			 long *offset);
unsigned long get_vmlinux_duplicate_symbol_pos(struct lookup_table *table, char *name,
                         unsigned long value);

#endif /* _LOOKUP_H_ */
